<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 38.40</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container">
    <div class="text-center mt-3 mb-3">
      <h2>F100 - Quản trị người dùng</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <label class="col-sm-2 col-form-label" for="firstNameInput">First name</label>
        <div class="col-sm-3">
          <input type="text" id="firstNameInput" class="form-control" placeholder="Nhap first name ...">
        </div>
        <label class="col-sm-2 col-form-label" for="lastNameInput">Last name</label>
        <div class="col-sm-3">
          <input type="text" id="lastNameInput" class="form-control" placeholder="Nhap last name ...">
        </div>
        <div class="col-sm-2">
          <button class="btn btn-success" id="btn-filter">Filter user</button>
        </div>
      </div>
    </div>
  </div>

  <div class="container mt-2">
    <div class="row">
      <div class="col-12 text-nowrap">
        <table id="table-users" class="table table-bordered table-striped table-hover">
          <thead>
            <tr>
              <th>Mã người dùng</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Country</th>
              <th>Subject</th>
              <th>Customer Type</th>
              <th>Register Status</th>
              <th>Action</th>
            </tr>
          </thead>
          <tbody>

          </tbody>
        </table>
      </div>
    </div>
  </div>
</body>
​
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  var gUsersArr = [];

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function () {
    // Gọi hàm onPageLoading() để load dữ liệu và hiển thị table khi trang được tải
    onPageLoading();

    // Gán sự kiện click cho nút "Filter user"
    $("#btn-filter").on("click", onFilterClick);

    // Gán sự kiện click cho nút "Chi tiết"
    $("#table-users").on("click", ".btn-detail", onDetailButtonClick);
  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  /**
   * Call API để get all users và lưu vào mảng toàn cục gUsersArr.
   * gUsersArr được sử dụng cho mục đích filter về sau
  */
  function onPageLoading() {
    // Gọi API để lấy dữ liệu users
    $.ajax({
      url: 'http://203.171.20.210:8080/devcamp-register-java-api/users',
      type: 'GET',
      dataType: 'json',
      success: function (response) {
        gUsersArr = response;
        fillDataTableUser(gUsersArr);
      },
      error: function () {
        console.log('Lỗi khi lấy dữ liệu users từ API');
      }
    });
  }

  /**
   * Hàm xử lý sự kiện khi click vào nút "Filter user"
   */
  function onFilterClick() {
    var firstName = $("#firstNameInput").val();
    var lastName = $("#lastNameInput").val();

    var filteredUsers = filterUsers(firstName, lastName);
    fillDataTableUser(filteredUsers);
  }

  /**
   * Hàm xử lý sự kiện khi click vào nút "Chi tiết"
   */
  function onDetailButtonClick() {
    var userId = $(this).closest("tr").find("td:first-child").text();
    alert("Mã người dùng: " + userId);
  }

  /*** REGION 4 - Common functions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  /**
   * Hàm lọc danh sách users dựa trên firstname và lastname
   */
  function filterUsers(firstName, lastName) {
    var filteredUsers = [];

    for (var i = 0; i < gUsersArr.length; i++) {
      var user = gUsersArr[i];
      if (user.firstname.toLowerCase().includes(firstName.toLowerCase()) &&
        user.lastname.toLowerCase().includes(lastName.toLowerCase())) {
        filteredUsers.push(user);
      }
    }

    return filteredUsers;
  }

  /**
   * Hàm load data vào table
   */
  function fillDataTableUser(users) {
    var userTable = $("#table-users tbody");
    userTable.empty();

    for (var i = 0; i < users.length; i++) {
      var user = users[i];
      var newRow = $("<tr/>").appendTo(userTable);
      $("<td/>", {
        html: user.id
      }).appendTo(newRow);
      $("<td/>", {
        html: user.firstname
      }).appendTo(newRow);
      $("<td/>", {
        html: user.lastname
      }).appendTo(newRow);
      $("<td/>", {
        html: user.country
      }).appendTo(newRow);
      $("<td/>", {
        html: user.subject
      }).appendTo(newRow);
      $("<td/>", {
        html: user.customerType
      }).appendTo(newRow);
      $("<td/>", {
        html: user.registerStatus
      }).appendTo(newRow);
      var actionCell = $("<td/>").appendTo(newRow);
      $("<button/>", {
        text: "Chi tiết",
        class: "btn btn-primary btn-detail"
      }).appendTo(actionCell);
    }
  }

</script>

</html>
​